GeoCompositeAreaShape (Lucene 10.5.0 spatial3d API)
Description: declaration: package: org.apache.lucene.spatial3d.geom, class: GeoCompositeAreaShape

Package org.apache.lucene.spatial3d.geom

# Class GeoCompositeAreaShape

java.lang.Object
org.apache.lucene.spatial3d.geom.BasePlanetObject
org.apache.lucene.spatial3d.geom.GeoBaseCompositeShape<GeoAreaShape>
org.apache.lucene.spatial3d.geom.GeoCompositeAreaShape

All Implemented Interfaces:
  `Bounded`, `GeoArea`, `GeoAreaShape`, `GeoBounds`, `GeoMembershipShape`, `GeoOutsideDistance`, `GeoShape`, `Membership`, `PlanetObject`, `SerializableObject`

public class GeoCompositeAreaShape extends GeoBaseCompositeShape<GeoAreaShape>
GeoCompositeAreaShape is a set of GeoAreaShape's, treated as a unit.

WARNING: This API is experimental and might change in incompatible ways in the next release.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `protected static final int`
  `ALL_INSIDE`
  All edgepoints inside shape
  `protected static final int`
  `NONE_INSIDE`
  No edgepoints inside shape
  `protected static final int`
  `SOME_INSIDE`
  Some edgepoints inside shape

  ### Fields inherited from class org.apache.lucene.spatial3d.geom.GeoBaseCompositeShape

  `shapes`

  ### Fields inherited from class org.apache.lucene.spatial3d.geom.BasePlanetObject

  `planetModel`

  ### Fields inherited from interface org.apache.lucene.spatial3d.geom.GeoArea

  `CONTAINS, DISJOINT, OVERLAPS, WITHIN`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `GeoCompositeAreaShape(PlanetModel planetModel)`
  Constructor.
  `GeoCompositeAreaShape(PlanetModel planetModel, InputStream inputStream)`
  Constructor for deserialization.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `double`
  `computeOutsideDistance(DistanceStyle distanceStyle, double x, double y, double z)`
  Compute this shape's distance to the GeoPoint.
  `double`
  `computeOutsideDistance(DistanceStyle distanceStyle, GeoPoint point)`
  Compute this shape's distance to the GeoPoint.
  `boolean`
  `equals(Object o)`
  `int`
  `getRelationship(GeoShape geoShape)`
  Find the spatial relationship between a shape and the current geo area.
  `boolean`
  `intersects(GeoShape geoShape)`
  Assess whether a shape intersects with any of the edges of this shape.
  `protected int`
  `isGeoAreaShapeInsideShape(GeoShape geoshape)`
  Determine the relationship between the GeoAreShape's edgepoints and the provided shape.
  `protected int`
  `isShapeInsideGeoAreaShape(GeoShape geoShape)`
  Determine the relationship between the GeoAreShape and the shape's edgepoints.
  `String`
  `toString()`

  ### Methods inherited from class org.apache.lucene.spatial3d.geom.GeoBaseCompositeShape

  `addShape, getBounds, getEdgePoints, getShape, getShapes, hashCode, intersects, isWithin, isWithin, size, write`

  ### Methods inherited from class org.apache.lucene.spatial3d.geom.BasePlanetObject

  `getPlanetModel`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface org.apache.lucene.spatial3d.geom.Bounded

  `getBounds`

  ### Methods inherited from interface org.apache.lucene.spatial3d.geom.GeoOutsideDistance

  `computeOutsideDistance, computeOutsideDistance`

  ### Methods inherited from interface org.apache.lucene.spatial3d.geom.GeoShape

  `getEdgePoints, intersects`

  ### Methods inherited from interface org.apache.lucene.spatial3d.geom.Membership

  `isWithin, isWithin`

  ### Methods inherited from interface org.apache.lucene.spatial3d.geom.PlanetObject

  `getPlanetModel`

  ### Methods inherited from interface org.apache.lucene.spatial3d.geom.SerializableObject

  `write`

- ## Field Details

  - ### ALL_INSIDE

    protected static final int ALL_INSIDE
    All edgepoints inside shape
    See Also:
      - Constant Field Values

  - ### SOME_INSIDE

    protected static final int SOME_INSIDE
    Some edgepoints inside shape
    See Also:
      - Constant Field Values

  - ### NONE_INSIDE

    protected static final int NONE_INSIDE
    No edgepoints inside shape
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### GeoCompositeAreaShape

    public GeoCompositeAreaShape(PlanetModel planetModel)
    Constructor.

  - ### GeoCompositeAreaShape

    public GeoCompositeAreaShape(PlanetModel planetModel, InputStream inputStream) throws IOException
    Constructor for deserialization.
    Parameters:
      `planetModel` - is the planet model.
      `inputStream` - is the input stream.
    Throws:
      `IOException`

- ## Method Details

  - ### equals

    public boolean equals(Object o)
    Overrides:
      `equals` in class `GeoBaseCompositeShape<GeoAreaShape>`

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `Object`

  - ### intersects

    public boolean intersects(GeoShape geoShape)
    Description copied from interface: `GeoAreaShape`
    Assess whether a shape intersects with any of the edges of this shape. Note well that this method must return false if the shape contains or is disjoint with the given shape. It is permissible to return true if the shape is within the specified shape, if it is difficult to compute intersection with edges.
    Specified by:
      `intersects` in interface `GeoAreaShape`
    Parameters:
      `geoShape` - is the shape to assess for intersection with this shape's edges.
    Returns:
      true if there's such an intersection, false if not.

  - ### getRelationship

    public int getRelationship(GeoShape geoShape)
    Description copied from interface: `GeoArea`
    Find the spatial relationship between a shape and the current geo area. Note: return value is how the GeoShape relates to the GeoArea, not the other way around. For example, if this GeoArea is entirely within the shape, then CONTAINS should be returned. If the shape is entirely enclosed by this GeoArea, then WITHIN should be returned.

    It is permissible to return OVERLAPS instead of WITHIN if the shape intersects with the area at even a single point. So, a circle inscribed in a rectangle could return either OVERLAPS or WITHIN, depending on implementation. It is not permissible to return CONTAINS or DISJOINT in this circumstance, however.

    Similarly, it is permissible to return OVERLAPS instead of CONTAINS under conditions where the shape consists of multiple independent overlapping subshapes, and the area overlaps one of the subshapes. It is not permissible to return WITHIN or DISJOINT in this circumstance, however.

    Specified by:
      `getRelationship` in interface `GeoArea`
    Parameters:
      `geoShape` - is the shape to consider.
    Returns:
      the relationship, from the perspective of the shape.

  - ### isShapeInsideGeoAreaShape

    protected int isShapeInsideGeoAreaShape(GeoShape geoShape)
    Determine the relationship between the GeoAreShape and the shape's edgepoints.
    Parameters:
      `geoShape` - is the shape.
    Returns:
      the relationship.

  - ### isGeoAreaShapeInsideShape

    protected int isGeoAreaShapeInsideShape(GeoShape geoshape)
    Determine the relationship between the GeoAreShape's edgepoints and the provided shape.
    Parameters:
      `geoshape` - is the shape.
    Returns:
      the relationship.

  - ### computeOutsideDistance

    public double computeOutsideDistance(DistanceStyle distanceStyle, GeoPoint point)
    Description copied from interface: `GeoOutsideDistance`
    Compute this shape's distance to the GeoPoint. A return value of 0.0 should be returned for points inside of the shape.
    Specified by:
      `computeOutsideDistance` in interface `GeoOutsideDistance`
    Parameters:
      `distanceStyle` - is the distance style.
      `point` - is the point to compute the distance to.
    Returns:
      the distance.

  - ### computeOutsideDistance

    public double computeOutsideDistance(DistanceStyle distanceStyle, double x, double y, double z)
    Description copied from interface: `GeoOutsideDistance`
    Compute this shape's distance to the GeoPoint. A return value of 0.0 should be returned for points inside of the shape.
    Specified by:
      `computeOutsideDistance` in interface `GeoOutsideDistance`
    Parameters:
      `distanceStyle` - is the distance style.
      `x` - is the point's unit x coordinate (using U.S. convention).
      `y` - is the point's unit y coordinate (using U.S. convention).
      `z` - is the point's unit z coordinate (using U.S. convention).
    Returns:
      the distance.